//***************************************************************************************************//
// Program testujcy uycie komponentw wysyania i odbioru UPO JPK - Jednolitego Pliku Kontrolnego
// autor: IPS Przedsibiorstwo Informatyczne - Marcin Konopka 2016r.
// rdo komponentu: JPKXMLComp.pas
// Wymagany modu biblioteki JPKLibUI.DLL
//***************************************************************************************************//

unit JPKXMLCompDemo_Form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, JPKXMLCompUnit, StdCtrls;

type
  TForm2 = class(TForm)
    JPKXMLFile1: TJPKXMLFile;
    JPKXMLOneFileSender1: TJPKXMLOneFileSender;
    Edit1: TEdit;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    Button2: TButton;
    Edit2: TEdit;
    Label2: TLabel;
    Button3: TButton;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure JPKXMLOneFileSender1FinishSend(Sender: TCustomJPKXMLSender;
      JPKXML: TCustomJPKXML);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    FTrwaSend: Boolean;
    FTrwaRefreshUPO: Boolean;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
begin
  //Wybr pliku
  if OpenDialog1.Execute then
  begin
    Edit1.Text:=OpenDialog1.FileName;
  end;
end;

procedure TForm2.Button2Click(Sender: TObject);
var
  vOrgCaption: String;
begin
  if FTrwaSend then
  begin
    JPKXMLOneFileSender1.SendBreak; //Przeryw wysyanie niezalenie od progressbar
    Exit;
  end;
  FTrwaSend:=true;
  try
    vOrgCaption:=Button2.Caption;
    Button2.Caption:='Przerwij'; //Powtrne nacinicie przerwie wysyanie.
    JPKXMLFile1.FileNamePath:=Edit1.Text;  //Ustawienie nazwy pliku XML
    JPKXMLOneFileSender1.ParentWinHandle:=Handle;  //Okna wysyki bd wyporodkowane nad oknem programu
    JPKXMLOneFileSender1.TestMode:=CheckBox1.Checked; //Ustawienie bramki docelowej - testowa lub produkcyjna
    JPKXMLOneFileSender1.Send(true); //Wysyanie
  finally
    Button2.Caption:=vOrgCaption;
    FTrwaSend:=false;
  end;
end;

procedure TForm2.Button3Click(Sender: TObject);
var
  vOrgCaption: String;
begin
  //Odczyt statusu i UPO dla numeru referencyjnego
  if FTrwaRefreshUPO then
  begin
    JPKXMLFile1.RefreshUPO(true); //Przerwij odczyt
    Exit;
  end;
  FTrwaRefreshUPO:=true;
  vOrgCaption:=Button3.Caption;
  Button3.Caption:='Przerwij';  //Powtrne nacinicie przerwie odczyt w przypadku problemw z cznoci
  try
    JPKXMLFile1.TestMode:=CheckBox1.Checked;
    JPKXMLFile1.RefreshUPO;
    With Memo1.Lines, JPKXMLFile1 do //Jeli nie ma Exception to jest sukces i wypisanie raportu
    begin
      if TestMode then
        Add('Sprawdzono status testowego: '+JPKXMLFile1.ReferenceNumber)
      else
        Add('Sprawdzono status'+JPKXMLFile1.ReferenceNumber);
      Add('Status: '+IntToStr(Status)+' - '+StatusText);
      if Status=200 then
        Add('UPO: '+Copy(UPO,1,50)+'...');
    end;
  finally
    FTrwaRefreshUPO:=false;
    Button3.Caption:=vOrgCaption;
  end;
end;

procedure TForm2.Edit2Change(Sender: TObject);
begin
  JPKXMLFile1.ReferenceNumber:=Edit2.Text  //Zapisanie do JPK numer referencyjnego
end;

procedure TForm2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=not JPKXMLOneFileSender1.IsSending;
  if not CanClose then
    ShowMessage('Aby zamkn program naley przerwa wysyanie lub poczeka.');
end;

procedure TForm2.JPKXMLOneFileSender1FinishSend(Sender: TCustomJPKXMLSender;
  JPKXML: TCustomJPKXML);
begin
  Edit2.Text:=JPKXML.ReferenceNumber;

  if JPKXML.Error.err<>0 then
    ShowMessage(JPKXML.Error.errMsg) //Poka ewentuualny komunikat bdu
  else
  With Memo1.Lines, (JPKXML as TJPKXMLFile) do
  begin
    if Sender.TestMode then
      Add('Wysano do bramki testowej: '+FileNamePath)
    else
      Add('Wysano '+FileNamePath);
    Add('Otrzymano numer referencyjny: '+ReferenceNumber);
    Add('Status: '+IntToStr(Status)+' - '+StatusText);
    if Status=200 then
      Add('UPO: '+Copy(UPO,1,50)+'...');
  end;




end;

end.
